<?php
/**
 * Nic_Device_www:: is a Nic_Device implementation to retrieve data
 * from a WWW server.
 *
 * @author  Mike Cochrane <mike@graftonhall.co.nz>
 * @since   Nic 0.2
 * @package Nic
 */
class Nic_Device_www extends Nic_Device {

    function Nic_Device_www($params = array())
    {
        $this->params = $params;
        $this->params['hostspec'] = isset($this->params['hostspec']) ?
            $this->params['hostspec'] :
            'localhost';
        $this->params['port'] = isset($this->params['port']) ?
            $this->params['port'] :
            80;
    }

    function getStatus()
    {
        $status = array();
        $status['status'] = NIC_STATUS_NORMAL;
        $status['message'] = '';

        $result = $this->_getServerResponse($this->params['hostspec'], $this->params['port']);

        $status['message'] .= 'Host: ' . $this->params['hostspec'] . "\n";
        if ($result == false || is_a($result, 'PEAR_Error')) {
            $status['message'] .= _("Connection Failed");
            $status['status'] = NIC_STATUS_FAULT;
        } else {
            $status['message'] .= $result;
            if (!empty($result) && substr($result, 0, 7) == 'HTTP/1.') {
                $status['status'] = NIC_STATUS_NORMAL;
            } else {
                $status['status'] = NIC_STATUS_WARN;
            }
        }
        $status['message'] .= "\n\n";

        return $status;
    }

    function _getServerResponse($host, $port)
    {
        require_once 'Net/Socket.php';
        $socket = &new Net_Socket();

        if (is_a($result = @$socket->connect($host, $port, false, 3), 'PEAR_Error')) {
            return false;
        } else {
            $socket->write("HEAD / HTTP/1.0\r\nHost: " . $this->params['hostspec'] . "\r\n\r\n");

            $result = '';
            $last = $socket->readLine();
            while (!empty($last)) {
                $result .= $last . "\n";
                $last = $socket->readLine();
            }

            $socket->disconnect();
            return $result;
        }
    }

}
